#include "type.h"

const QDBusArgument &operator<<(QDBusArgument &argument, const QStringPair &string)
{
    argument.beginStructure();
    argument << string.name;
    argument << string.key;
    argument << string.mediaKey;
    argument.endStructure();
    return argument;
}

const QDBusArgument &operator>>(const QDBusArgument &argument, QStringPair &string)
{
    argument.beginStructure();
    argument >> string.name;
    argument >> string.key;
    argument >> string.mediaKey;
    argument.endStructure();
    return argument;
}

const QDBusArgument &operator<<(QDBusArgument &argument, const KeyEntry &key)
{
    argument.beginStructure();
    argument << key.gsSchema;
    argument << key.keyStr;
    argument << key.valueStr;
    argument << key.descStr;
    argument << key.gsPath;
    argument << key.nameStr;
    argument << key.bindingStr;
    argument << key.actionStr;
    argument.endStructure();
    return argument;
}

const QDBusArgument &operator>>(const QDBusArgument &argument, KeyEntry &key)
{
    argument.beginStructure();
    argument >> key.gsSchema;
    argument >> key.keyStr;
    argument >> key.valueStr;
    argument >> key.descStr;
    argument >> key.gsPath;
    argument >> key.nameStr;
    argument >> key.bindingStr;
    argument >> key.actionStr;
    argument.endStructure();
    return argument;
}
